#!/bin/bash
#
# This kio-bashin script allow to KDE Debian users to browse their APT database and installed packages.
#

eval LAST=\${$#}

tmpfile="/tmp/kwed_tmp.txt"
indexfile="/tmp/kwed_idx.txt"
sections="/tmp/kwed_sect.txt"
lock="/tmp/kwed_lock.txt"

function lock {
	echo 1 > $lock
}

function unlock {
	rm $lock
}

if [ "$1" == "*mime" ]
then
	echo "audio/mpeg3"
fi

if [ "$1" == "*file" ]
then
	URL="`cat $indexfile|grep "$LAST"|sed -n "s/\[url:\([^]]*\).*/\\1/p"`"
	wget "http://remix.kwed.org/$URL" -O "/tmp/$LAST"
	cat "/tmp/$LAST"
	rm "/tmp/$LAST"
fi

if [ "$1" == "*dir" ]
then
	if [ "$2" == "" ]
	then
		if [ -e "$lock" ]
		then
			echo
		else
			lock
			wget http://remix.kwed.org/ -O $tmpfile 2>/dev/null
			cat $tmpfile|sed -n "/^<tr>$/ {
				n
				n
				s/.*download.php\/\([^\"]*\)\".*/[url:download.php\/\\1]/
				h
				s/\[url:download.php.*\//\[key:/
				s/\//-/g
				s/%20/ /g
				s/%28/'/g
				s/%29/'/g
				s/%27/'/g
				H
				n
				n
				n
				s/.*>\([^<]*\)<.*/[author:\\1]/
				s/\//-/g
				s/\&amp;/\&/g
				H
				x
				s/\n//g
				p
			}" > $indexfile
			cat $indexfile |sed -n "s/.*\[author:\([^]]*\)\]/\\1/p"|sort|uniq > $sections
			rm $tmpfile
			unlock
		fi
		cat $sections|sed "s/^/*/"
	else
		cat $indexfile|grep "\[author:$2\]"|sed -n "s/.*\[key:\([^]]*\)\].*/.\\1\n0*audio\/mpeg3/p"
	fi
fi

